export function areaChart(fD , id){ // function to handle lineChart.
  
		
  
    var parseDate = d3.timeParse("%m/%d/%Y");

    var margin = {left: 50, right: 20, top: 20, bottom: 50 };

    var width = 700 - margin.left - margin.right;
    var height = 400 - margin.top - margin.bottom;


    var max = 0;

    var xNudge = 50;
    var yNudge = 20;

    var minDate = new Date();
    var maxDate = new Date();

		var data = fD;
		var titles = Object.keys(data[0]);	
		      
  
			data.forEach(function(d) {
        d[titles[0]]= parseDate(d[titles[0]])
        for(let i=1;i<titles.length;i++)
        		d[titles[i]]= Number(d[titles[i]]);
      });
      
  		var svg = d3.select(id).append("svg").attr("id","svg").attr("height",height+100).attr("width",width+100)
        		.attr("transform","translate("+20+","+50+")");
      var chartGroup = svg.append("g").attr("class","chartGroup").attr("transform","translate("+xNudge+","+(yNudge)+")");
  
  
      var rowToChart = function( rows , i ){
        
        
        max = d3.max(rows, function(d) { return d[titles[i]] });
        minDate = d3.min(rows, function(d) {return d[titles[0]] });
        maxDate = d3.max(rows, function(d) { return d[titles[0]] });
				// console.log(max);
				// console.log(minDate);
				// console.log(maxDate);
        
        var y = d3.scaleLinear()
              .domain([0,max])
              .range([height,0]);

        var x = d3.scaleTime()
              .domain([minDate,maxDate])
              .range([0,width]);

        var yAxis = d3.axisLeft(y);

        var xAxis = d3.axisBottom(x);

        var colorz=["red","blue","yellow","brown","purple","green","lime"];
        var color = colorz[Math.floor(Math.random() * colorz.length)];
        
        // define the area
        var area = d3.area()
            .x(function(d) { return x(d[titles[0]]); })
            .y0(height)
            .y1(function(d) { return y(d[titles[i]]); })
        		.curve(d3.curveCardinal);
        
        
        var line = d3.line()
          .x(function(d){ return x(d[titles[0]]); })
          .y(function(d){ return y(d[titles[i]]); })
          .curve(d3.curveCardinal);


      	// add the area
    		chartGroup.append("path")
           //.data([data])
           .attr("class", "area")
           .attr("d",function(d){ return area(rows); })
        	 .style("fill",color)
        	 .style("opacity",0.5);
        
        chartGroup.append("path")
          .attr("class","line")
          .attr("d",function(d){ return line(rows); })
        	.style("stroke",color);
        	
        
				if (i==1)
        {
        chartGroup.append("g")
          .attr("class","axis x")
          .attr("transform","translate(0,"+(height)+")")
          .call(xAxis);

        chartGroup.append("g")
          .attr("class","axis y")
          .call(yAxis);
        }
      };
  
  		for(let i=1;i<titles.length;i++)
  				rowToChart(data , i);
};