export function Venn(fD , id){ // function to handle Venn.
 



    var sets = fD;


  	var vennn = d3.select(id).append("div")    
                    .attr("id", "venn");
  

    var svgContainer = vennn.append("svg")
                                         .attr("width",500)
                                         .attr("height",500);

    var venngroup = svgContainer.append("g")    
                    .attr("id", "venngroup");
    

    var chart = venn.VennDiagram()
                     .width(500)
                     .height(500 )
                     .styled(false);

    var div = d3.select("#venngroup")
    div.datum(sets).call(chart);



    div.selectAll("g.venn-area")
        .on("mouseover", function(d, i) {
            // sort all the areas relative to the current item
            venn.sortAreas(div, d);
        })





    var stuffToBeWrapped = d3.selectAll("svg");

    stuffToBeWrapped.each(function() {

       d3.select( this.childNode ).insert("g", function(){return this;} ) 
                  //insert a new <g> element immediately before this element
         .attr("class", "wrapper") //set anything you want to on the <g>
         .append( function(){return this;} );
                 //move the content element into the group

    });
}