export function concentricCircles(fD , id){ // function to handle concentricCircles.

    var dataset = fD;

    var width = 600,
      height = 600,
      cwidth = 300;
  
    var leng = dataset.length;


    var color = d3.scaleOrdinal(d3.schemeOranges[leng]);

    var svgContainer = d3.select(id).append("svg")
                     .attr("width", width)
                     .attr("height", height)
                     .style('margin-left','50px')
                     .style('margin-top','50px');

    var circles = svgContainer.selectAll("circle").data(dataset);
    var circles2 = circles.enter().append("g");



    var circleAttributes = circles2.append("circle")
                           .attr("cx", width/2)
                           .attr("cy", height/2)
                           .attr("r", function (d , i) { return cwidth-(cwidth/leng*i); })
                           .style("fill", function(d) {
                             return color(d.text);
                           });

    circles2.append("text")
            .attr("x", function(d, i){ return width/2})
            .attr("y", function(d, i){ return cwidth-(cwidth/leng*(leng-i))+cwidth/leng/2;})
            .text(function(d){return d.text})
            .attr('text-anchor', 'middle')
            .attr('alignment-baseline', 'middle')
            .style('font-size', function(d,i){return (24-i*2)+ 'px'} );
  
}