export function forceField(fD , id){ // function to handle forceField.
 
  
  	var height = 600;
    var width = 900;
	
  	
  
  	var titles = Object.keys(fD[0]);
  
    var plan = fD[0][titles[0]];//plan
  
    for(let i=0;i<fD.length;i++)
      delete fD[i][titles[0]];
  
  	//var myData = fD.slice(1, fD.length);
  	
  	var column1 = [],column2 = [];
  	var sum1=0,sum2=0;
  
  	for(var i=0;i<fD.length;i++)
    {
      if (fD[i][titles[1]]!="")
      	column1.push(fD[i][titles[1]]);

      if (fD[i][titles[3]]!="")
      	column2.push(fD[i][titles[3]]);
      
      if (fD[i][titles[2]]!="")
      	sum1 += (+fD[i][titles[2]]);

      if (fD[i][titles[4]]!="")
      	sum2 += (+fD[i][titles[4]]);
    }
  
  	var maxi = Math.max(column1.length,column2.length );
  	

    var svgContainer = d3.select(id).append("svg")
                     .attr("width", width)
                     .attr("height", height)
                     .style('margin-left','50px')
                     .style('margin-top','50px');

    var circles = svgContainer.selectAll("#rect1").data(column1);
  
    var circles2 = circles.enter().append("g");
		
  


    var circleAttributes = circles2.append("rect")
    			.attr("id", 'rect1')
          .attr("width", 250)
          .attr("height", 40)
          .attr("x", 50)
          .attr("y", function (d , i) { return 20+i*70; })
          .style("fill", "red");

  	var tri = d3.symbol().type(d3.symbolTriangle).size(1200);
  	circles2.append("path")
    .attr("d", tri)
    .attr("transform", function (d , i) { return "translate(310,"+(20+i*70+20)+")rotate(90)"})
  	.style("fill", "red");
  
    circles2.append("text")
            .attr("x", 50+250)
            .attr("y", function (d , i) { return 20+i*70+20; })
            .text(function(d){console.log(d); return d})
            .attr('text-anchor', 'end')
            //.attr('alignment-baseline', 'middle')
            .style('font-size', (20 + 'px') );
  
  	var circles_ = svgContainer.selectAll("#rect2").data(column2);
  
    var circles2_ = circles_.enter().append("g");



    var circleAttributes_ = circles2_.append("rect")
    			.attr("id", 'rect2')
          .attr("width", 250)
          .attr("height", 40)
          .attr("x", 600)
          .attr("y", function (d , i) { return 20+i*70; })
          .style("fill", "lime");

  	circles2_.append("path")
    .attr("d", tri)
    .attr("transform", function (d , i) { return "translate(590,"+(20+i*70+20)+")rotate(-90)"})
  	.style("fill", "lime");
  
    circles2_.append("text")
            .attr("x", 600)
            .attr("y", function (d , i) { return 20+i*70+20; })
            .text(function(d){console.log(d); return d})
            .attr('text-anchor', 'start')
            //.attr('alignment-baseline', 'middle')
            .style('font-size', (20 + 'px') );
  
  
  	svgContainer.append("rect")
    			.attr("id", 'rect3')
          .attr("width", 150)
          .attr("height", maxi*70)
          .attr("x", 375)
          .attr("y", 10 )
          .style("fill", "white")
  				.style("stroke-width", "2px")
  				.style("stroke", "black");

  	plan = wordWrap(plan, 10);
  	var plan2 = plan.split("\n");
  
  	for (var i = 0; i < plan2.length; i++) {
      
				svgContainer.append("text")
            .attr("x", 375+75)
            .attr("y", maxi*70/3+25*i)
            .text(plan2[i])
            .attr('text-anchor', 'middle')
            .attr('alignment-baseline', 'middle')
            .style('font-size', (20 + 'px') );
        }
  
  	console.log(titles);

  
  
  
  
    

		function wordWrap(str, maxWidth) {
    var newLineStr = "\n"; let done = false; let res = '';
    while (str.length > maxWidth) {                 
        let found = false;
        // Inserts new line at first whitespace of the line
        for (i = maxWidth - 1; i >= 0; i--) {
            if (testWhite(str.charAt(i))) {
                res = res + [str.slice(0, i), newLineStr].join('');
                str = str.slice(i + 1);
                found = true;
                break;
            }
        }
        // Inserts new line at maxWidth position, the word is too long to wrap
        if (!found) {
            res += [str.slice(0, maxWidth), newLineStr].join('');
            str = str.slice(maxWidth);
        }

    }

    return res + str;
		}
  
    function testWhite(x) {
      var white = new RegExp(/^\s$/);
      return white.test(x.charAt(0));
};
}